import { jsxs as b, jsx as s, Fragment as re } from "react/jsx-runtime";
import { useState as w, useEffect as P } from "react";
import { i as _, j as I, m as u, l as g, I as ne, x as se, n as oe, R as H, e as V, o as U, P as G, T as le } from "./UserOptions-d360c716-cc2f77cb.js";
import "react-router-dom";
import "react-redux";
const W = (o, e) => ("" + o).padStart(2, "0") + (e || ""), E = (o, e) => ("" + o).substring(2) + (e || ""), T = (o, e, t) => {
  const a = I[o];
  return (e ? a.substring(0, 4) : a) + (t || "");
};
class m {
  /**
   * Calendar constructor
   *
   * @param  options  Calendar options
   */
  constructor({
    startDate: e = null,
    endDate: t = null,
    siblingMonths: a = !1,
    weekNumbers: n = !1,
    weekStart: d = 0
  } = {}) {
    this.startDate = e, this.endDate = t, this.siblingMonths = a, this.weekNumbers = n, this.weekStart = d;
  }
  /**
   * Calculate a calendar month
   *
   * @param   year   Year
   * @param   month  Month [0-11]
   * @return         Calendar days
   */
  getCalendar(e, t) {
    const a = new Date(Date.UTC(e, t, 1, 0, 0, 0, 0));
    e = a.getFullYear(), t = a.getMonth();
    const n = [], d = a.getDay(), r = -((7 - this.weekStart + d) % 7), M = m.daysInMonth(e, t), N = (M - r) % 7, D = m.daysInMonth(e, t - 1);
    let l = r, c, h, f = !1, x = null, p, Y;
    const R = M - l + (N !== 0 ? 7 - N : 0) + r;
    for (; l < R; )
      h = l + 1, c = ((l < 1 ? 7 + l : l) + d) % 7, h < 1 || h > M ? this.siblingMonths ? (h < 1 ? (p = t - 1, Y = e, p < 0 && (p = 11, Y--), h = D + h) : h > M && (p = t + 1, Y = e, p > 11 && (p = 0, Y++), h = l - M + 1), p !== void 0 && Y !== void 0 && (f = {
        day: h,
        weekDay: c,
        month: p,
        year: Y,
        siblingMonth: !0
      })) : f = !1 : f = {
        day: h,
        weekDay: c,
        month: t,
        year: e
      }, f && this.weekNumbers && (x === null ? x = m.calculateWeekNumber(f) : c === 1 && x === 52 ? x = 1 : c === 1 && x++, f.weekNumber = x), f && this.startDate && (f.selected = this.isDateSelected(f)), n.push(f), l++;
    return n;
  }
  /**
   * Checks if a date is selected
   *
   * @param   date  Date object
   * @return        Selected status of the date
   */
  isDateSelected(e, t) {
    if (!this.startDate || t === null)
      return !1;
    let a = this.startDate;
    return t ? m.compare(this.startDate, t) === 1 && (a = t, t = this.startDate) : t = this.endDate, e.year === a.year && e.month === a.month && e.day === a.day ? !0 : !(!t || e.year === a.year && e.month === a.month && e.day < a.day || e.year === t.year && e.month === t.month && e.day > t.day || e.year === a.year && e.month < a.month || e.year === t.year && e.month > t.month || e.year < a.year || e.year > t.year);
  }
  /**
   * Sets the selected period start
   *
   * @param  date  Date object
   */
  setStartDate(e) {
    this.startDate = e;
  }
  /**
   * Sets the selected period end
   *
   * @param  date  Date object
   */
  setEndDate(e) {
    this.endDate = e;
  }
  /**
   * Sets one selected date
   *
   * @param  date  Date object
   */
  setDate(e) {
    return this.setStartDate(e);
  }
  /**
   * Calculates the difference between two dates (date1 - date2), in days
   *
   * @param   dateLeft   Date object
   * @param   dateRight  Date object
   * @return             Days between the dates
   */
  static diff(e, t) {
    const a = new Date(
      Date.UTC(e.year, e.month, e.day, 0, 0, 0, 0)
    ), n = new Date(
      Date.UTC(t.year, t.month, t.day, 0, 0, 0, 0)
    );
    return Math.ceil(
      (a.getTime() - n.getTime()) / 864e5
    );
  }
  /**
   * Calculates the interval between two dates
   *
   * @param   dateLeft   Date object
   * @param   dateRight  Date object
   * @return             Number of days between dates
   */
  static interval(e, t) {
    return Math.abs(m.diff(e, t)) + 1;
  }
  /**
   * Quickly compare two dates
   *
   * @param   dateLeft   Left `CalendarDate` object
   * @param   dateRight  Right `CalendarDate` object
   * @return             Comparison result: -1 (left < right), 0 (equal) or 1 (left > right)
   */
  static compare(e, t) {
    if (typeof e != "object" || typeof t != "object" || e === null || t === null)
      throw new TypeError("dates must be objects");
    return e.year < t.year ? -1 : e.year > t.year ? 1 : e.month < t.month ? -1 : e.month > t.month ? 1 : e.day < t.day ? -1 : e.day > t.day ? 1 : 0;
  }
  /**
   * Calculates the number of days in a month
   *
   * @param   year  Year
   * @param   month Month [0-11]
   * @return        Length of the month
   */
  static daysInMonth(e, t) {
    return new Date(e, t + 1, 0).getDate();
  }
  /**
   * Calculates if a given year is a leap year
   *
   * @param   year  Year
   * @return        Leap year or not
   */
  static isLeapYear(e) {
    return e % 4 === 0 && e % 100 !== 0 || e % 400 === 0;
  }
  /**
   * Calculates the week number for a given date
   *
   * @param   date  Date object
   * @return        Week number
   */
  // Adapted from http://techblog.procurios.nl/k/news/view/33796/14863/calculate-iso-8601-week-and-year-in-javascript.html
  static calculateWeekNumber(e) {
    const t = new Date(
      Date.UTC(e.year, e.month, e.day, 0, 0, 0, 0)
    ), a = new Date(t.valueOf()), n = (t.getUTCDay() + 6) % 7;
    a.setUTCDate(a.getUTCDate() - n + 3);
    const d = a.valueOf();
    return a.setUTCMonth(0, 1), a.getUTCDay() !== 4 && a.setUTCMonth(0, 1 + (4 - a.getUTCDay() + 7) % 7), 1 + Math.ceil((d - a.getTime()) / 6048e5);
  }
  static toString(e, t = "/", a = "DDMMYYYY") {
    const n = W(e.day, t), d = W(e.month + 1, t), r = e.year;
    switch (a) {
      case _.MMDDYY:
        return d + n + E(r);
      case _.DDMMYYYY:
        return n + d + r;
      case _.MMDDYYYY:
        return d + n + r;
      case _.DDMMMYY:
        return n + T(e.month + 1, !0, t) + E(r);
      case _.DDMMMYYYY:
        return n + T(e.month + 1, !0, t) + r;
      case _.MMMDDYY:
        return T(e.month + 1, !0, t) + n + E(r);
      case _.MMMDDYYYY:
        return T(e.month + 1, !0, t) + n + r;
      case _.YYMMDD:
        return E(r) + d + n;
      case _.YYMMMDD:
        return E(r) + T(e.month + 1, !0, t) + n;
      case _.YYYYMMDD:
        return r + d + n;
      case _.YYYYMMMDD:
        return r + T(e.month + 1, !0, t) + n;
      case _.DDMMYY:
      default:
        return n + d + E(r);
    }
  }
  static getPreviousMonth(e) {
    const t = e.getMonth(), a = e.getFullYear(), n = t === 0 ? 11 : t - 1, d = t === 0 ? a - 1 : a, r = /* @__PURE__ */ new Date();
    return r.setDate(e.getDate()), r.setMonth(n), r.setFullYear(d), r;
  }
  static getNextMonth(e) {
    const t = e.getMonth(), a = e.getFullYear(), n = t === 11 ? 0 : t + 1, d = t === 11 ? a + 1 : a, r = /* @__PURE__ */ new Date();
    return r.setDate(e.getDate()), r.setMonth(n), r.setFullYear(d), r;
  }
  static getPreviousYear(e) {
    const t = e.getFullYear(), a = /* @__PURE__ */ new Date();
    return a.setDate(e.getDate()), a.setMonth(e.getMonth()), a.setFullYear(t === 1 ? 1 : t - 1), a;
  }
  static getNextYear(e) {
    const t = e.getFullYear(), a = /* @__PURE__ */ new Date();
    return a.setDate(e.getDate()), a.setMonth(e.getMonth()), a.setFullYear(t + 1), a;
  }
}
const ie = (o) => {
  let e = +(("" + o).substring(0, 2) + "00");
  const t = e + 100, a = [];
  for (; e < t; )
    a.push({ start: e + 1, end: e + 10 }), e += 10;
  return a;
}, ce = (o) => {
  let e = o + 1;
  const t = e + 10, a = [];
  for (; e < t; )
    a.push(e), e++;
  return a;
}, de = (o) => {
  const {
    currentDecade: e,
    currentMonthNavView: t,
    currentYear: a,
    miniMode: n,
    onMonthSelect: d,
    setCurrentDecade: r,
    setCurrentMonthNavView: M,
    setCurrentView: N,
    setCurrentYear: D
  } = o;
  return /* @__PURE__ */ b("div", { className: "ar-MonthSelector position-absolute h-100 d-flex w-100 overflow-hidden", children: [
    /* @__PURE__ */ s(
      "div",
      {
        className: `ar-MonthSelector__decade-selector position-absolute h-100 w-100 d-flex flex-wrap${t === u.DECADE ? " start-0" : " start-100"}`,
        children: e && ie(e).map((l) => /* @__PURE__ */ s(
          "div",
          {
            className: `ar-MonthSelector__decade-selector__decade-padder d-flex ${n ? "p-0" : "p-3"}`,
            onClick: () => {
              r(l.start - 1), M(u.YEAR);
            },
            children: /* @__PURE__ */ s(
              "div",
              {
                className: `ar-MonthSelector__decade-selector__decade flex-center flex-1 cursor-pointer${n ? "" : " border border-radius"}`,
                children: l.start + " - " + E(l.end)
              }
            )
          }
        ))
      }
    ),
    /* @__PURE__ */ s(
      "div",
      {
        className: `ar-MonthSelector__year-selector position-absolute w-100 h-100 d-flex flex-wrap${t === u.YEAR ? " start-0" : t === u.MONTH ? " start-100" : " start-n100"}`,
        children: e && ce(e).map((l) => /* @__PURE__ */ s(
          "div",
          {
            className: `ar-MonthSelector__year-selector__year-padder d-flex ${n ? "p-0" : "p-3"}`,
            onClick: () => {
              D(l), M(u.MONTH);
            },
            children: /* @__PURE__ */ s(
              "div",
              {
                className: `ar-MonthSelector__year-selector__year flex-center flex-1 cursor-pointer${n ? "" : " border border-radius"}`,
                children: l
              }
            )
          }
        ))
      }
    ),
    /* @__PURE__ */ s(
      "div",
      {
        className: `ar-MonthSelector__month-selector position-absolute w-100 h-100 d-flex flex-wrap${t === u.MONTH ? " start-0" : " start-n100"}`,
        children: I.map((l, c) => /* @__PURE__ */ s(
          "div",
          {
            className: `ar-MonthSelector__month-selector__month-padder d-flex ${n ? "p-0" : "p-3"}`,
            onClick: () => {
              const h = /* @__PURE__ */ new Date();
              h.setMonth(c), h.setFullYear(+(a || h.getFullYear())), d(h), M(null), N(g.CALENDAR);
            },
            children: /* @__PURE__ */ s(
              "div",
              {
                className: `ar-MonthSelector__month-selector__month flex-center flex-1 cursor-pointer${n ? "" : " border border-radius"}`,
                children: l
              }
            )
          }
        ))
      }
    )
  ] });
}, he = [
  {
    name: "Monday",
    short: "Mo",
    index: 0
  },
  {
    name: "Tuesday",
    short: "Tu",
    index: 1
  },
  {
    name: "Wednesday",
    short: "We",
    index: 2
  },
  {
    name: "Thursday",
    short: "Th",
    index: 3
  },
  {
    name: "Friday",
    short: "Fr",
    index: 4
  },
  {
    name: "Saturday",
    short: "Sa",
    index: 5
  },
  {
    name: "Sunday",
    short: "Su",
    index: 6
  }
], ue = (o, e) => "day" in o ? (o = o, e.day === o.day && e.month === o.month && e.year === o.year) : (o = o, e.day === o.getDate() && e.month === o.getMonth() && e.year === o.getFullYear()), De = (o) => {
  const {
    allowEventSetting: e,
    calendar: t,
    calHelper: a,
    endDate: n,
    hovered: d,
    isSingleSelect: r,
    miniMode: M,
    setHovered: N,
    onDateSelected: D,
    startDate: l
  } = o;
  return /* @__PURE__ */ b(
    "ul",
    {
      className: `ar-JustCalendar list-unstyled d-flex flex-wrap flex-1 position-relative mb-0 ${M ? "is-mini p-1" : "p-3"}`,
      onMouseLeave: () => N(null),
      children: [
        he.map((c) => /* @__PURE__ */ s("li", { className: "ar-JustCalendar__day ar-Calendar__weekday fw-bold flex-center", children: /* @__PURE__ */ s("span", { className: "ar-JustCalendar__day__short", children: c.short }) })),
        t == null ? void 0 : t.map((c) => {
          const h = c && ue(/* @__PURE__ */ new Date(), c);
          return c ? /* @__PURE__ */ s(
            "li",
            {
              slot: ne.ANCHOR,
              className: `ar-JustCalendar__day flex-center cursor-pointer${c.siblingMonth ? " ar-JustCalendar__sibling-month" : ""}${a != null && a.isDateSelected(c) ? " selected" : ""}${h ? " today" : ""}${a != null && a.isDateSelected(c, d) ? " selectable" : ""}`,
              onClick: () => D(c),
              onMouseOver: () => {
                a != null && a.startDate && !a.endDate && !r && N(c);
              },
              children: /* @__PURE__ */ b("span", { className: "ar-JustCalendar__day__date flex-center position-relative", children: [
                h && /* @__PURE__ */ s(
                  se,
                  {
                    type: oe.COMPLETE,
                    size: H.SMALL,
                    classes: "ar-JustCalendar__day__badge position-absolute"
                  }
                ),
                c.day
              ] })
            }
          ) : /* @__PURE__ */ s("li", {});
        })
      ]
    }
  );
}, me = (o) => {
  const { events: e, miniMode: t, selectedDate: a } = o;
  return /* @__PURE__ */ s("div", { className: "ar-EventForm position-absolute h-100 w-100", children: /* @__PURE__ */ s("div", { className: "ar-EventForm__header border-bottom py-2 px-3", children: /* @__PURE__ */ s("span", { className: "fw-bold", children: W(a.day) + " - " + W(a.month + 1) + " - " + a.year }) }) });
}, Me = (o, e) => {
  const t = e || o.getFullYear(), a = Math.floor(t / 10) * 10, n = a + 10;
  return a + 1 + " - " + n;
}, ye = (o, e) => {
  const t = e || o.getFullYear(), a = Math.floor(t / 100) * 100, n = a + 100;
  return a + 1 + " - " + n;
}, ge = (o) => {
  const {
    currentDecade: e,
    currentMonthNavView: t,
    currentView: a,
    currentYear: n,
    miniMode: d,
    refDate: r,
    setCurrentDecade: M,
    setCurrentMonthNavView: N,
    setCurrentView: D,
    setCurrentYear: l,
    setRefDate: c,
    theme: h
  } = o;
  return /* @__PURE__ */ s(
    "div",
    {
      className: `ar-MonthNavigator border-bottom d-flex${d ? " is-mini px-0 py-1" : " px-3 py-2"}${a === g.MONTH_YEAR_SELECTOR ? " to-month-year" : ""}${u.MONTH === t ? " to-month-selector" : ""}`,
      children: /* @__PURE__ */ b("div", { className: "d-flex w-100", children: [
        /* @__PURE__ */ s(
          "div",
          {
            className: "ar-MonthNavigator__nav-button flex-center cursor-pointer",
            onClick: () => c(m.getPreviousYear(r)),
            children: /* @__PURE__ */ s(
              V,
              {
                icon: "ai/AiOutlineDoubleLeft",
                color: h === U.DARK1 ? "white" : "black",
                size: "1rem",
                strokeWidth: d ? "30" : "100"
              }
            )
          }
        ),
        /* @__PURE__ */ s(
          "div",
          {
            className: "ar-MonthNavigator__nav-button flex-center cursor-pointer",
            onClick: () => {
              a === g.CALENDAR ? c(m.getPreviousMonth(r)) : t === u.MONTH ? l((n || r.getFullYear()) - 1) : M(
                (e || 2e3) - (t === u.DECADE ? 100 : 10)
              );
            },
            children: /* @__PURE__ */ s(
              V,
              {
                icon: "ai/AiOutlineLeft",
                color: h === U.DARK1 ? "white" : "black",
                size: "1rem",
                strokeWidth: d ? "30" : "100"
              }
            )
          }
        ),
        /* @__PURE__ */ s(
          "div",
          {
            className: `ar-MonthNavigator__nav-button ar-MonthNavigator__month d-inline-flex flex-center cursor-pointer overflow-auto${t === u.DECADE ? " disabled" : ""}`,
            onClick: () => {
              a === g.CALENDAR && D(g.MONTH_YEAR_SELECTOR), t === u.MONTH ? N(u.YEAR) : t === u.YEAR ? N(u.DECADE) : N(u.MONTH);
            },
            children: a === g.MONTH_YEAR_SELECTOR ? t === u.MONTH ? n || r.getFullYear() : t === u.YEAR ? Me(r, e) : ye(r, e) : /* @__PURE__ */ b(re, { children: [
              /* @__PURE__ */ s("span", { className: "me-1", children: I[r.getMonth()] }),
              /* @__PURE__ */ s("span", { children: r.getFullYear() })
            ] })
          }
        ),
        /* @__PURE__ */ s(
          "div",
          {
            className: "ar-MonthNavigator__nav-button flex-center cursor-pointer",
            onClick: () => {
              a === g.CALENDAR ? c(m.getNextMonth(r)) : t === u.MONTH ? l((n || r.getFullYear()) + 1) : M(
                (e || 2e3) + (t === u.DECADE ? 100 : 10)
              );
            },
            children: /* @__PURE__ */ s(
              V,
              {
                icon: "ai.AiOutlineRight",
                color: h === U.DARK1 ? "white" : "black",
                size: "1rem",
                strokeWidth: d ? "30" : "100"
              }
            )
          }
        ),
        /* @__PURE__ */ s(
          "div",
          {
            className: "ar-MonthNavigator__nav-button flex-center cursor-pointer",
            onClick: () => c(m.getNextYear(r)),
            children: /* @__PURE__ */ s(
              V,
              {
                icon: "ai.AiOutlineDoubleRight",
                color: h === U.DARK1 ? "white" : "black",
                size: "1rem",
                strokeWidth: d ? "30" : "100"
              }
            )
          }
        )
      ] })
    }
  );
}, v = new m({ siblingMonths: !0, weekStart: 1 }), L = /* @__PURE__ */ new Date(), pe = (o) => {
  const {
    allowEventSetting: e,
    classes: t,
    events: a,
    customDayEventSetter: n,
    hasTimeControls: d,
    isSingleSelect: r,
    maxDate: M,
    minDate: N,
    miniMode: D,
    onDateSelected: l,
    startDate: c,
    endDate: h,
    theme: f
  } = o, [x, p] = w(), [Y, R] = w(L), [y, A] = w(), [$, S] = w(), [K, Q] = w(), [ee, X] = w(), [k, F] = w(
    g.CALENDAR
  ), [Z, j] = w(), O = y || {
    day: L.getDay(),
    month: L.getMonth(),
    year: L.getFullYear()
  }, [q, z] = w(
    (O == null ? void 0 : O.year) && Math.floor(O.year / 10) * 10
  ), [B, J] = w(
    O == null ? void 0 : O.year
  );
  P(() => {
    c && A({
      year: c.getFullYear(),
      month: c.getMonth(),
      day: c.getDay()
    });
  }, [c]), P(() => {
    h && S({
      year: h.getFullYear(),
      month: h.getMonth(),
      day: h.getDay()
    });
  }, [h]), P(() => {
    if (Y) {
      const i = Y.getFullYear(), C = Y.getMonth(), ae = v.getCalendar(i, C);
      p(ae);
    }
  }, [Y]);
  const te = (i, C) => {
    if (!y || r) {
      A(i), v.setStartDate(i), l && l(r ? i : { startDate: i });
      return;
    }
    y && $ ? m.compare(y, i) === -1 && m.compare(i, $) === -1 ? (v.setEndDate(i), S(i), l && l(
      r ? i : { startDate: y, endDate: i }
    )) : (v.setEndDate(null), S(null), v.setStartDate(i), A(i), l && l(
      r ? i : { startDate: i, endDate: null }
    )) : (m.compare(i, y) === -1 ? (S(y), v.setEndDate(y), A(i), v.setStartDate(i), l && l(
      r ? i : { startDate: i, endDate: y }
    )) : (S(i), v.setEndDate(i), l && l(
      r ? i : { startDate: y, endDate: i }
    )), X(null)), C && e && (Q(i), F(g.EVENT_FORM));
  };
  return /* @__PURE__ */ b(
    "div",
    {
      className: `ar-Calendar w-100 h-100 d-flex flex-column${d ? " has-time-controls" : ""}${t ? " " + t : ""}`,
      children: [
        Y && /* @__PURE__ */ s(
          ge,
          {
            currentDecade: q,
            currentMonthNavView: Z,
            currentView: k,
            currentYear: B,
            miniMode: D,
            refDate: Y,
            setCurrentDecade: z,
            setCurrentMonthNavView: j,
            setCurrentView: F,
            setCurrentYear: J,
            setRefDate: R,
            theme: f
          }
        ),
        /* @__PURE__ */ b(
          "div",
          {
            className: `ar-Calendar__cal-event-decade-month-year-selector d-flex flex-1 position-relative overflow-hidden border-bottom${k === g.MONTH_YEAR_SELECTOR ? " to-month-year" : ""}${k === g.EVENT_FORM ? " to-event-form" : ""}${D ? " is-mini" : ""}`,
            children: [
              /* @__PURE__ */ s(
                De,
                {
                  allowEventSetting: e,
                  calHelper: v,
                  calendar: x,
                  endDate: $,
                  hovered: ee,
                  isSingleSelect: r,
                  miniMode: D,
                  onDateSelected: te,
                  setHovered: X,
                  startDate: y
                }
              ),
              /* @__PURE__ */ s(
                de,
                {
                  currentDecade: q,
                  currentMonthNavView: Z,
                  currentView: k,
                  currentYear: B,
                  miniMode: D,
                  onMonthSelect: (i) => {
                    F(g.CALENDAR), R(i);
                  },
                  setCurrentDecade: z,
                  setCurrentMonthNavView: j,
                  setCurrentView: F,
                  setCurrentYear: J
                }
              ),
              K && /* @__PURE__ */ s(
                me,
                {
                  events: a,
                  miniMode: D,
                  selectedDate: K
                }
              )
            ]
          }
        ),
        /* @__PURE__ */ b(
          "div",
          {
            className: `ar-Calendar__footer flex-v-center${D ? " p-2" : " px-3 py-2"}${k === g.EVENT_FORM ? " h-0 overflow-hidden" : ""}`,
            children: [
              y && !D && /* @__PURE__ */ s("div", { className: "ar-Calendar__status justify-self-start", children: /* @__PURE__ */ b("span", { className: "fw-bold", children: [
                m.toString(y),
                $ && " - " + m.toString($)
              ] }) }),
              /* @__PURE__ */ b("div", { className: "ar-Calendar__controls ms-auto d-flex", children: [
                /* @__PURE__ */ s(
                  G,
                  {
                    content: "Clear",
                    classes: D ? "me-2" : "me-3",
                    size: D ? H.XSMALL : H.SMALL,
                    variant: le.SECONDARY,
                    onClick: () => {
                      A(null), S(null), v.setStartDate(null), v.setEndDate(null);
                    },
                    disabled: !y
                  }
                ),
                /* @__PURE__ */ s(
                  G,
                  {
                    content: "Today",
                    size: D ? H.XSMALL : H.SMALL,
                    onClick: () => {
                      const i = L, C = {
                        day: i.getDay(),
                        month: i.getMonth(),
                        year: i.getFullYear()
                      };
                      A(C), S(null), v.setStartDate(C), v.setEndDate(null), R(i), z(Math.floor(C.year / 10) * 10), J(C.year), j(null), F(g.CALENDAR), l && l(
                        r ? C : { startDate: C, endDate: null }
                      );
                    }
                  }
                )
              ] })
            ]
          }
        )
      ]
    }
  );
};
export {
  pe as Z
};
